/* eslint-disable @typescript-eslint/no-unsafe-return */
/**
 * Turns the null values of an object into undefined
 */
export function nullToUndefined(value) {
    if (typeof value !== 'object')
        return value; // typeof `null` is an object
    if (value === null)
        return undefined;
    if (Array.isArray(value)) {
        return value.map((item) => nullToUndefined(item));
    }
    const newObj = {};
    for (const k of Object.keys(value)) {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        const v = value[k];
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        newObj[k] =
            v === null
                ? undefined
                : // eslint-disable-next-line no-proto
                    v && typeof v === 'object' && v.__proto__.constructor === Object
                        ? nullToUndefined(v)
                        : v;
    }
    return newObj;
}
